/*
 * irp_solver_exact.h
 *
 *  Created on: 27 de jul de 2016
 *      Author: hokama
 */

#ifndef IRP2D_SOLVER_EXACT_H_
#define IRP2D_SOLVER_EXACT_H_

#include <sstream>
#include "irp2d_instance.h"

namespace IRP2D {

class Irp2dSolverExact {
private:
  int verbose;
  int threads;
  double total_time;
  double time_limit;
  double time_for_packing_cp_solver;

public:
  Irp2dSolverExact();
  virtual ~Irp2dSolverExact();

  //Solves the instance
  int solve(Irp2dInstance &inst);

  //getters and setters
  void set_verbose(int v){verbose = v;}
  void set_threads(int t){threads = t;}
  void set_time_limit(double t){time_limit = t;}
  double get_time_limit(){return time_limit;}
  void set_time_packing_cp_solver_limit(double t){time_for_packing_cp_solver = t;}

  //getters after solving
  double get_total_time(){return total_time;}
};

} /* namespace IRP2D */

#endif /* IRP2D_SOLVER_EXACT_H_ */
