#include "irp2d_subtourelim2d.h"

namespace IRP2D {

int getPacking(Irp2dInstance *inst, vector < pair < int, int > > route){
  for(unsigned i = 0; i < inst->routes.size(); i++){
    if(inst->routes[i].size() != route.size()) continue;
    bool equal = true;
    for(unsigned v = 0; v < inst->routes[i].size(); v++){
      if(route[v].first != inst->routes[i][v].first) equal = false;
      if(route[v].second != inst->routes[i][v].second) equal = false;
    }
    if (equal) return i;
  }
  return -1;
}

//just-in-time
int getPacking(Irp2dInstance *inst, vector <int> route_nodes, int period){
  for(unsigned i = 0; i < inst->routes.size(); i++){
    if(period != inst->routes[i][0].second || inst->routes[i].size() != route_nodes.size()) continue;
    bool equal = true;
    for(unsigned v = 0; v < inst->routes[i].size(); v++){
      if(route_nodes[v] != inst->routes[i][v].first) equal = false;
    }
    if (equal) return i;
  }
  return -1;
}


void printPackings(Irp2dInstance *inst){
  cout << "Number of routes on table: " << inst->routes.size() << " " << endl;
  for(unsigned i = 0; i < inst->routes.size(); i++){
    cout << setw(4) << i << " route size " << inst->routes[i].size();
    for(unsigned v = 0; v < inst->routes[i].size(); v++){
      cout << "(" << inst->routes[i][v].first << ", " << inst->routes[i][v].second << ") ";
    }
    for(unsigned item = 0; item < inst->x_routes[i].size(); item++){
      cout << "(" << inst->x_routes[i][item] << "," << inst->y_routes[i][item] << ") ";
    }
    cout << endl;
  }
  return;
}

}// end of namespace

